#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "IOStringBug", Category = "VVVV", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class VVVVIOStringBugNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Node ID")]
		public ISpread<int> FNodeId;
		
		[Input("Spread String", DefaultString = "nada")]
		public ISpread<string> FSpreadString;
		
		[Input("Do", IsBang = true)]
		public ISpread<bool> FDo;

		[Output("Output")]
		public ISpread<string> FOutput;

		[Import()]
		public ILogger FLogger;
		
		[Import()]
		public IHDEHost FHDE;
		
		[Import()]
		public IPluginHost2 FHost;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			for (int i=0; i<SpreadMax; i++)
			{
				if (FDo[i])
				{
					string path = FHost.GetNodePath(false).Replace(FHost.GetID().ToString(),FNodeId[i].ToString());
					
					var node = FHDE.GetNodeFromPath(path);
					foreach (var p in node.Pins)
					{
						if (p.Name.Contains("Input"))
						{
							FOutput[i] = p.Spread;
							p.Spread = FSpreadString[i];
						}
					}
				}
			}

			//FLogger.Log(LogType.Debug, "hi tty!");
		}
	}
}
